mostly new music stuff
[distro-setup] / brc2
diff --git a/brc2 b/brc2
index 61bd93109a60b49b3e78c64b06f0bdbf680ae124..9dda87b0930740b7896e601fd780e452b887dcfc 100644 (file)
--- a/brc2
+++ b/brc2
@@ -380,6 +380,434 @@ astudio() {
   /a/opt/android-studio/bin/studio.sh "$@" &r;
 }
 
+
+iki() {
+  local url path
+  if [[ $1 ]]; then
+    path="$*"
+  else
+    read -r -p "enter path" path
+  fi
+  url=$(readlink -f "$path")
+  url="https://brains.fsf.org/wiki/${url#*brains/}"
+  url="${url%.mdwn}"
+  echo "$url"
+  # /f/brains/sysadmin/interns/2022/nick_shrader/intro_blog_post.mdwn
+  # becomes
+  # https://brains.fsf.org/wiki/sysadmin/interns/2022/nick_shrader/intro_blog_post
+
+}
+
+# Generate beet smartplaylists for navidrome.
+# for going in the reverse direction, run
+# /b/ds/navidrome-playlist-export
+beetsmartplaylists() {
+  install -m 0700 -d /tmp/ianbeetstmp
+  beet splupdate
+  # kill off any playlists we deleted. they will still need manual
+  # killing from a navidrome client.
+  rm -rf /i/converted/beetsmartplaylists
+  mkdir -p /i/converted/beetsmartplaylists
+  for f in /tmp/ianbeetstmp/*; do
+    sed 's,^/i/m,/i/converted,;s,\.flac$,.mp3,' "$f" >"/i/converted/beetsmartplaylists/${f##*/}"
+    rm "$f"
+  done
+  rmdir /tmp/ianbeetstmp
+}
+
+# Export beets ratings into navidrome
+beetrating() {
+  local tmp tmpfile myuser userid rating path cpath sqlpath
+  # plucked this from the db. im the only user.
+  userid=23cc2eb9-e35e-4811-a0f0-d5f0dd6eb634
+  tmpfile=$(mktemp)
+  beet ls -f '$rating $path' ^genre:spoken-w ^genre:skit rating:2..5 >$tmpfile
+  while read -r rating path; do
+    tmp="/i/converted${path#/i/m}"
+    cpath="${tmp%.*}.mp3" # converted path
+    sqlpath="${cpath//\'/\'\'}"
+    old_rating=$(sqlite3 /i/navidrome/navidrome.db "select rating from annotation inner join media_file on item_id = id where path = '$sqlpath' and item_type = 'media_file';")
+    if [[ $old_rating ]]; then
+      if [[ $old_rating != $rating ]]; then
+        # https://stackoverflow.com/a/50317320
+        m sqlite3 /i/navidrome/navidrome.db "
+update annotation set rating = $rating
+ where item_id in (
+ select media_file.id from annotation inner join media_file on annotation.item_id = media_file.id
+   where media_file.path = '$sqlpath' and annotation.item_type = 'media_file' );"
+      fi
+    else
+      # /a/opt/navidrome/persistence/sql_annotations.go v0.48.0
+      # https://www.sqlite.org/lang_insert.html
+      m sqlite3 /i/navidrome/navidrome.db "insert into annotation select '$(uuidgen)', '$userid', id, 'media_file', 0, NULL, $rating, 0, NULL from media_file where path = '$sqlpath';"
+    fi
+    #sqlite3 /i/navidrome/navidrome.db "select path from annotation inner join media_file on item_id = id where rating = $r;"
+  done <$tmpfile
+}
+
+# Do transcoding and hardlinking of audio files for navidrome.
+#
+# This deletes files in the converted directory which should no longer
+# be there due to a rename of the unconverted file.
+beetconvert() {
+  local l query
+  local -A paths
+  query="^genre:spoken-w ^genre:skit ^lesser_version:t ^rating:1"
+  # redirect is to avoid printing every file
+  beet convert -y $query >/dev/null 2> >(grep -v '^convert: Skipping' ||:)
+
+  ## begin removal of files that are leftover from previous conversion,
+  # eg, previously rated > 1, now rated 1.
+  while read -r l; do
+    convertedpath="/i/converted${l#/i/m}"
+    case $convertedpath in
+      *.flac) convertedpath="${convertedpath%.flac}.mp3" ;;
+    esac
+    paths[$convertedpath]=t
+  done < <(beet ls -f '$path' $query)
+  while read -r l; do
+    if [[ ! ${paths[$l]} ]]; then
+      rm -v "$l"
+    fi
+    # note: the pruning is duplicative of filtering on name, but whatever.
+  done < <(find /i/converted -path /i/converted/beetsmartplaylists -prune -o \( -type f -print \) -name '*.mp3' -o -name '*.m4a')
+  ## end
+}
+
+# tag with beets.
+# usage: beetag QUERY
+# it lists the query, reads an input char for tagging one by one.
+# 1-5 = set rating
+# a-x 0 6-9 / . , = set genre/playlist. (available buttons: ` \ ) ] [
+# q = quit
+# y = toggle to setting rare genres
+# z = put the player in the foreground
+# enter = next song
+# ' = toggle playing of songs, also replays current song if hit twice
+# ; = go to previous song
+# _ = delete file, remove from library
+# -/+ = decrease / increase volume
+#
+# note, you may want to change the play command for doing rapid taging
+# by immediately jumping forward into the song. this is set in the beets
+# config yaml.
+beetag() {
+  local last_genre_i fstring tag id char new_item char_i genre tag remove doplay i j random
+  local do_rare_genres read_wait
+  local -a genres pl_tags buttons button_map ids tags rare_genres tmp_tags
+  local -A button_i
+  local -i volume
+  do_rare_genres=false
+  random=false
+  volume=70
+  read_wait=2
+  case $1 in
+    -r)
+      random=true
+      shift
+      ;;
+  esac
+  if (( ! $# )); then
+    echo beetag: error expected a query arg >&2
+    return 1
+  fi
+  doplay=true
+  genres=(
+    # gangsta rap / angry rap. something like g-rap would make beet queries for genre:rap include it
+    arp
+    ambient
+    avant
+    blues
+    classical
+    # slow instrumental. todo: reclassify some ambient into this.
+    chill
+    country
+    # like power glove
+    dark-wave
+    # lyrical edm. todo: some pop needs reclassification to this
+    dance
+    hardcore
+    instrumental
+    latin
+    metal
+    # mq = mac quale. similar to the mr robot soundtracks.
+    # slow, foreboding. usually electronic.
+    mq
+    pop
+    rap
+    rock
+    # like rain by brian crain. mostly slow broody piano
+    sleep
+    techno
+    world
+  )
+  # because we were destined to run out of single key buttons.
+  rare_genres=(
+    jazz
+    musical
+    noise
+    skit
+    spoken-w
+  )
+  pl_tags=(
+    ## cross-genre tags that dont really make a playlist
+    expl
+    # songs i like but they get old fast due to feeling gimicky, or cringy after a while.
+    gimicky
+    # alternate version of a song we already have which isn't as good
+    lesser_version
+    # anything sad which i sometimes like or avoid.
+    sad
+
+    ## playlists
+    # intimate, love
+    love
+    # favorite songs pump up songs
+    pump1
+    # favorite rap pump up songs, allows more songs than pump1
+    pumprap
+    # heart rending, spine tickling
+    rend
+    # for running
+    run
+  )
+  last_genre_i=$(( ${#genres[@]} - 1 ))
+  buttons=( {a..p} {r..w} 0 {6..9} , . / )
+  button_map=(${genres[@]} ${pl_tags[@]})
+  fstring=
+  for tag in "${pl_tags[@]}"; do
+    fstring+="%ifdef{$tag,$tag }"
+  done
+
+  for (( i=0; i<${#buttons[@]}; i++ )); do
+    button_i[${buttons[i]}]=$i
+  done
+  beet ls -f '%ifdef{rating,$rating }'"$fstring"', $genre $artist - $album - $title' "$@"
+  mapfile -t ids < <(beet ls -f '$id' "$@" | { if $random; then sort -R; else cat; fi; } )
+  for (( j=0; j<${#ids[@]}; j++ )); do
+    hr
+    id=${ids[j]}
+    lsout="$(beet ls -f '%ifdef{rating,$rating }'"$fstring"', $genre $id $artist - $album - $title' "id:$id")"
+    tags=( ${lsout%%,*} )
+    printf "%s\n" "$lsout"
+    for (( i=0; i<${#button_map[@]}; i++ )); do
+      echo ${buttons[i]} ${button_map[i]}
+    done
+    if $doplay; then
+      beet play --args=--volume=$volume "id:$id" &
+    fi
+    while true; do
+      char=
+      if $doplay; then
+        ret=0
+        read -r -N 1 -s -t $read_wait char || ret=$?
+        read_wait=2
+        # Automatically skip to the next song if this one ends, unless
+        # we turn off the autoplay.
+        if (( ret == 142 )) || [[ ! $char ]]; then
+          if bg %% &>/dev/null; then
+            continue
+          else
+            break
+          fi
+        fi
+      else
+        read -r -N 1 -s char
+      fi
+      if [[ $char == $'\n' ]]; then
+        kill %% ||: &>/dev/null
+        break
+      fi
+      case $char in
+        ";")
+          kill %% ||: &>/dev/null
+          j=$(( j - 2 ))
+          break
+          ;;
+        "'")
+          if $doplay; then
+            doplay=false
+          else
+            doplay=true
+            kill %% ||: &>/dev/null
+            beet play --args=--volume=$volume "id:$id" &
+          fi
+          continue
+          ;;
+        _)
+          kill %% ||: &>/dev/null
+          m beet rm --delete --force "id:$id"
+          break
+          ;;
+        [1-5])
+          beet modify -y "id:$id" rating=$char
+          continue
+          ;;
+        -)
+          volume=$(( volume - 5 ))
+          if (( volume < 0 )); then
+            volume=0
+          fi
+          echo volume=$volume
+          continue
+          ;;
+        q)
+          kill %% ||: &>/dev/null
+          return
+          ;;
+        +)
+          volume+=5
+          if (( volume > 130 )); then
+            volume=130
+          fi
+          echo volume=$volume
+          continue
+          ;;
+        y)
+          if $do_rare_genres; then
+            do_rare_genres=false
+            button_map=(${genres[@]} ${pl_tags[@]})
+            last_genre_i=$(( ${#rare_genres[@]} - 1 ))
+          else
+            do_rare_genres=true
+            button_map=(${rare_genres[@]} ${pl_tags[@]})
+            last_genre_i=$(( ${#genres[@]} - 1 ))
+          fi
+          local -A button_i
+          for (( i=0; i<${#buttons[@]}; i++ )); do
+            button_i[${buttons[i]}]=$i
+          done
+          for (( i=0; i<${#button_map[@]}; i++ )); do
+            echo ${buttons[i]} ${button_map[i]}
+          done
+          continue
+          ;;
+        z)
+          # if we ctrl-z, it will put the whole function into sleep. so
+          # basically, we can't return from a foregrounded mpv like we
+          # would like to without some strange mechanism I can't think
+          # of. So, instead, detect ctrl-c and wait a while for prompt
+          # input. One idea would be to use a music player like mpd where
+          # we can send it messages.
+          if ! fg; then
+            sleep_wait=10
+          fi
+          continue
+          ;;
+      esac
+      char_i=${button_i[$char]}
+      new_item=${button_map[$char_i]}
+      if [[ ! $char_i || ! $new_item ]]; then
+        echo "error: no mapping of input: $char found, try again"
+        continue
+      fi
+      if (( char_i <= last_genre_i )); then
+        m beet modify -y "id:$id" genre=$new_item
+      else
+        remove=false
+        tmp_tags=()
+        for tag in ${tags[@]}; do
+          if [[ $new_item == "$tag" ]]; then
+            remove=true
+          else
+            tmp_tags+=("$tag")
+          fi
+        done
+        if $remove; then
+          tags=("${tags[@]}")
+          m beet modify -y "id:$id" "$new_item!"
+        else
+          tags+=("$new_item")
+          m beet modify -y "id:$id" $new_item=t
+        fi
+      fi
+    done
+  done
+}
+
+# usage: FILE|ALBUM_DIR [GENRE]
+beetadd() {
+  local import_path genre_arg single_track_arg
+  import_path="$1"
+  if [[ ! -e $import_path ]]; then
+    echo "beetadd error: path does not exist"
+  fi
+  if [[ $2 ]]; then
+    genre_arg="--set genre=$2"
+  fi
+  if [[ -f $import_path ]]; then
+    single_track_arg=-s
+  fi
+  beet import --set totag=t $single_track_arg $genre_arg "$import_path"
+  beetag totag:t
+  beet modify -y totag:t "totag!"
+}
+
+# update navidrome music data after doing beets tagging
+beet2nav() {
+  beetconvert
+  beetsmartplaylists
+  beetrating
+}
+
+# pull in beets library locally
+beetpull() {
+  if [[ ! -e /i ]]; then
+    s mkdir /i
+    s chown iank:iank /i
+    sshfs b8.nz:/i /i
+  fi
+}
+
+# escape regex.
+#
+# This is not perfect but generally good enough. It escapes all
+# metachars listed man 3 pcrepattern.
+er() {
+  sed 's/[]\\^$.[|()?*+{}]/[&]/g; s/\^/\\^/g' <<<"$*"
+}
+
+# usage beegenre QUERY
+#
+# beet set genre for QUERY based on existing artist most used genre on
+#
+# inverse of query for each artist found in QUERY. If query starts with
+# "artist:" it is used as the artist instead of each artist in QUERY.
+#
+beegenre() {
+  local artist artregex genre term singleartist
+  local -a artists genres terms
+  singleartist=false
+  case $1 in
+    artist:*)
+      singleartist=true
+      artist="$term"
+      ;;
+  esac
+  if $singleartist; then
+    read count genre < <(beet ls -f '$genre' "$artist" "${@/#/^}" | sort | uniq -c | sort -n | tail -n1) ||:
+    beet modify "$artist" "$@" genre=$genre
+  else
+    while read -r artist; do
+      artregex=$(er "$artist")
+      read count genre < <(beet ls -f '$genre' "artist::^$artregex$" "${@/#/^}" | sort | uniq -c | sort -n | tail -n1) || continue
+      if [[ $count ]]; then
+        artists+=("$artregex")
+        genres+=("$genre")
+        echo "beet modify -y $@ \"artist::^$artist$\" genre=$genre # $count"
+      fi
+    done < <(beet ls -f '$artist' "$@" | sort -u)
+    read -r -N 1 -s -p "Y/n " char
+    case $char in
+      [Yy$'\n'])
+        for (( i=0; i<${#artists[@]}; i++ )); do
+          beet modify -y "$@"  "artist::^${artists[i]}$" genre=${genre[i]}
+        done
+        ;;
+    esac
+  fi
+}
+
 # note, to check for glue records
 # First, find some the .org nameservers:
 # dig +trace iankelling.org
@@ -458,6 +886,54 @@ scr() {
   screen -RD "$@"
 }
 
+# usage: first get an adb shell on the phone.
+#
+# just followed instructions in readme at
+# https://github.com/Yuubi-san/ceb-tools
+# tried to use ceb2txt but it failed because of schema
+# slightly different than what it expected.
+cheogram-get-logs() {
+  adb shell rm -r /storage/emulated/0/Download/Cheogram/Backup
+  read -p "do cheogram backup on phone, do not enable extra cheogram data. press any key when done"
+  cd /p/cheogram
+  rm -rf Backup b
+  adb pull /storage/emulated/0/Download/Cheogram/Backup
+  sqlite3 b </a/opt/ceb-tools/schema.sql
+  echo "note: the next step took 39 seconds last time i measured"
+  /a/opt/ceb-tools/ceb2sqlgz Backup/iank@fsf.org.ceb <pas | gunzip | sqlite3 b
+  rm -r Backup
+}
+
+# usage: cheologs [DAYS_LIMIT]
+# default days is 100
+cheologs() {
+  local days q
+  days=${1:-100}
+  q="
+select
+ datetime(substr(timeSent,0,11),  'unixepoch'),
+ replace(replace(counterpart,'@fsf.org',''),
+        '@conference.fsf.org',''),
+ body
+from messages
+where timeSent > $(( (EPOCHSECONDS - days * 60 * 60 * 24) * 1000 ))
+order by timeSent;"
+  sqlite3 /p/cheogram/b ".mode tabs" "$q" | less
+}
+
+mycheologs() {
+  local days q
+  days=${1:-16}
+  q="
+select
+ datetime(substr(timeSent,0,11),  'unixepoch'),
+ body
+from messages
+where timeSent > $(( (EPOCHSECONDS - days * 60 * 60 * 24) * 1000 ))
+and counterpart = 'office@conference.fsf.org/iank'
+order by timeSent;"
+  sqlite3 /p/cheogram/b ".mode tabs" "$q" | sed 's/ /./' | less
+}
 
 # version of jdo for my non-root user
 jdo() {
@@ -1268,7 +1744,7 @@ lom() {
       m sudo losetup $l $fs_file
     fi
     if ! sudo cryptsetup status /dev/mapper/$base &>/dev/null; then
-      if ! sudo cryptsetup luksOpen $l $base; then
+      if ! sudo cryptsetup luksOpen $l $base; then
         m sudo losetup -d $l
         return 1
       fi
@@ -1419,6 +1895,9 @@ mpvm() {
   # get page source of https://en.wikipedia.org/w/index.php?title=Video_file_format&action=edit
   # into /a/x.log, then
   # grep '^| *\.' /a/x.log | sed 's/| *//;s/,//g'
+
+  #  note: to join them together for a regex, do:
+  # old=; for e in ${extensions[@]/./}; do if [[ ! $old ]]; then old=$e; continue; fi; echo -n "$old|"; old=$e; done; echo $e
   extensions=(
     .webm
     .mkv